# Welcome, b3L0v3D h4ck3r!

This node is part of the DeTEE hacker-challenge, a decentralized wallet that mints the HCT Token.
The private key of the mint authority was generated within the network. The challenge is easy:
Hack the network to get the private key, and all the SOL is yours. We also offer other rewards, including:
- a unique NFT
- token rewards at after release of the DeTEE token
- a seat on the Advisory Board of DeTEE
- possible employment at DeTEE

The mint address of the token is: TOKEN_ADDRESS
The mint authority is: MINT_AUTHORITY

In order to mint, the mint authority will need some SOL. Before sending SOL, take into consideration that
DeTEE REPRESENTATIVES DON'T KNOW HOW TO GET THE SOL OUT OF THE NETWORK!

Allowed operations:
/nodes          <- information about nodes and counters of network activity
/mint (address) <- mint HCT tokens to the address; the wallet needs sol for this operation

If you are able to get the SOL out of the wallet, please contact us at https://detee.ltd
The code of the challenge can be found at https://gitea.detee.cloud/SGX/hacker-challenge-sgx

## More about the network

Each node in the network runs inside an enclave. The enclave is a program that operates in a trusted execution environment (TEE). Memory of programs within the enclave can not be inspected from outside the enclave. Programs within the enclave have access to sources of entropy that cannot be predicted from outside. Programs can also access reproducible secrets that they can use to seal[^1] persistent data. Each enclave has a certain set of measurements, consisting of all the data required for the program to run (instructions, configuration, etc.). A running program can generate a quote that can be used to verify the measurements and legitimacy of the hardware it's running on.

Assuming there are no vulnerabilities in any of the mentioned hardware features, and our node implementation has none either, it should be practically impossible to steal the SOL from the network wallet because:
- wallet key is generated with the enclave's source of entropy
- nobody can inspect the memory that contains the key
- nodes verify the quote of each peer and refuse connections if quote measurements don't match their own
- node seals[^1] all persistent data saved to disk with the enclave's key

[^1]: use symmetric encryption to encrypt some data before exposing it to untrusted environment to later recover the data by decrypting
