#!/bin/sh

# This script is the entrypoint of the challenge container

if [ -z "${INIT_NODES}" ]; then
  echo "The INIT_NODES environment variable is not set."
else
  echo $INIT_NODES | tr ' ' '\n' > detee_challenge_nodes
fi

if [ -z "${NODE_IP}" ]; then
  echo "The NODE_IP environment variable is not set."
else
  echo $NODE_IP > detee_node_ip
fi

occlum run /bin/hacker-challenge
